<script lang="ts">
  import dedent from "dedent-js"
  import Prism from "svelte-prism"

  import { browser } from "$app/environment"
  import { goto } from "$app/navigation"
  import { page } from "$app/stores"
  import type { Access } from "$lib/access"
  import type {
    Commune,
    CommuneCollectiviteOutreMer,
  } from "$lib/code_officiel_geographique"
  import type { Epci } from "$lib/epci"
  import ErrorAlert from "$lib/components/errors/ErrorAlert.svelte"
  import JsonTree from "$lib/components/JsonTree.svelte"
  import type { EpciSuggestion } from "$lib/suggestions"

  import type { PageData } from "./$types"

  export let data: PageData

  let init = true
  const { url } = $page
  const { searchParams } = url
  const fields = searchParams.getAll("field")
  let communesField = fields.includes("communes")
  let epciField = fields.includes("epci")
  let q = searchParams.get("q") ?? ""

  $: ({ error, suggestions } = data)

  $: handleChange(q, epciField, communesField)

  $: sourceCode = dedent`
      const response = await fetch(
        ${JSON.stringify(new URL(url.pathname, url.origin))} +
          ${JSON.stringify(
            "?" + searchFromParams(q, epciField, communesField),
          )},
        { headers: { Accept: "application/json" } }
      );
      const { suggestions } = await response.json();
    `

  async function handleChange(
    q: string,
    epciField: boolean,
    communesField: boolean,
  ): Promise<void> {
    if (browser) {
      if (init) {
        init = false
      } else {
        const search = searchFromParams(q, epciField, communesField)
        await goto(`${url.pathname}${search ? "?" + search : ""}`, {
          keepFocus: true,
          noScroll: true,
        })
      }
    }
  }

  function searchFromParams(
    q: string,
    epciField: boolean,
    communesField: boolean,
  ): string {
    return new URLSearchParams(
      [
        ["q", q ?? undefined],
        ["field", epciField ? "epci" : undefined],
        ["field", communesField ? "communes" : undefined],
      ].filter(([, value]) => value !== undefined) as Array<[string, string]>,
    ).toString()
  }

  function summarize(
    access: Access | undefined,
    value: unknown,
  ): string | undefined {
    if (access === undefined) {
      return undefined
    } else if (access.access === undefined) {
      const suggestion = value as EpciSuggestion
      return suggestion.role === undefined
        ? suggestion.autocompletion
        : `${suggestion.autocompletion} (${suggestion.libelle})`
    } else if (access.access.key === "communes") {
      const commune = value as Commune & CommuneCollectiviteOutreMer
      return `${commune.LIBELLE} (${commune.COM ?? commune.COM_COMER})`
    } else if (access.key === "epci") {
      const epci = value as Epci
      return `${epci.LIBEPCI} (${epci.EPCI})`
    } else {
      return undefined
    }
  }
</script>

<header class="prose my-6 max-w-full">
  <h1>
    Service de suggestion d'établissements publics à caractère intercommunal
    (EPCI)
  </h1>
</header>

{#if error != null}
  <ErrorAlert {error} />
{/if}

<form class="mx-auto max-w-lg" on:submit|preventDefault>
  <div class="form-control">
    <label class="label cursor-pointer">
      <span class="label-text">EPCI</span>
      <input
        class="input-bordered input w-full max-w-xs"
        type="text"
        placeholder="Nom d'EPCI ou commune"
        bind:value={q}
      />
    </label>
  </div>
  <div class="form-control">
    <label class="label cursor-pointer">
      <span class="label-text">Informations sur l'EPCI</span>
      <input bind:checked={epciField} class="checkbox" type="checkbox" />
    </label>
  </div>
  <div class="form-control">
    <label class="label cursor-pointer">
      <span class="label-text">Informations sur les communes de l'EPCI</span>
      <input bind:checked={communesField} class="checkbox" type="checkbox" />
    </label>
  </div>
</form>

<section>
  <header class="prose my-4 max-w-full">
    <h2>Requête</h2>
  </header>

  <div>
    <Prism language="javascript" source={sourceCode} />
  </div>
</section>

{#if error == null}
  <section>
    <header class="prose my-4 max-w-full">
      <h2>Suggestions</h2>
    </header>

    {#if !suggestions?.length}
      <p><i>Aucune suggestion</i></p>
    {:else}
      <div>
        <JsonTree frame={false} open {summarize} value={suggestions} />
      </div>
    {/if}
  </section>
{/if}
